<template>
  <!-- <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button type="primary" circle v-show="!editable" @click="editable = !editable">编辑</el-button>
    <el-button type="primary" v-show=editable @click="saveData">确定</el-button>
  </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>502#底盖冲床工序生产质量记录</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>
      <div class="title_form_input">
        <span>记录员：</span>
        <span>{{ headData.head.jiluyuan }}</span>
      </div>
      <div class="title_form_input">
        <span>接班时间：</span>
        <span>{{ headData.head.jieban1 }}</span>
      </div>
      <div class="title_form_input">
        <span>交班时间：</span>
        <span>{{ headData.head.jiaoban1 }}</span>
      </div>
    </div>
    <el-divider />

    <HJTABLE
      :SClist="c_tieqkHeaderData"
      :tableHeader="c_tieqkHeader"
      :labelName="labelName.b1"
      :editable="editable"
    >
    </HJTABLE>
    <HJTABLE
      :SClist="c_spHeaderData"
      :tableHeader="c_spHeader"
      :labelName="labelName.b2"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="c_baseHeaderData"
      :tableHeader="c_baseHeader"
      :labelName="labelName.b3"
      :editable="editable"
    >
    </HJTABLE>

    <HJTABLE
      :SClist="c_wgHeaderData"
      :tableHeader="c_wgHeader"
      :labelName="labelName.b4"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { chongVoLast, chongVoSave } from "@/api/gaixian";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const router = useRouter();

    const c_spHeader = reactive([
      { prop: "shijian11", label: "时间", editable: "false", type: "text" },
      { prop: "sudu", label: "速度", editable: "false", type: "text" },
      { prop: "yali", label: "压力", editable: "false", type: "text" },
    ]);

    const c_baseHeader = reactive([
      { prop: "shijian11", label: "时间", editable: false, type: "text" },
      { prop: "xm", label: "检测项目", editable: false, type: "text" },
      { prop: "bzz", label: "标准值", editable: false, type: "text" },
      { prop: "no1", label: "1#模", editable: false, type: "text" },
      { prop: "no2", label: "2#模", editable: false, type: "text" },
      { prop: "no3", label: "3#模", editable: false, type: "text" },
    ]);
    const c_tieqkHeader = reactive([
      { prop: "jiebtsy", label: "接班铁剩余", editable: false, type: "text" },
      { prop: "jiaobtsy", label: "交班铁剩余", editable: false, type: "text" },
      { prop: "ctzl", label: "冲铁总量", editable: false, type: "text" },
      { prop: "kgs", label: "亏盖数", editable: false, type: "text" },
      { prop: "yf", label: "印废", editable: false, type: "text" },
      { prop: "fp", label: "废品", editable: false, type: "text" },
    ]);
    const c_wgHeader = reactive([
      { prop: "shijian11", label: "时间", editable: false, type: "text" },
      { prop: "wgjc", label: "外观检测", editable: false, type: "text" },
      { prop: "qxyy", label: "缺陷原因", editable: false, type: "text" },
      { prop: "cstz", label: "措施调整", editable: false, type: "text" },
    ]);

    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });

    let labelName = {
      b1: "铁使用情况",
      b2: "生产速度与压力",
      b3: "基本尺寸",
      b4: "外观检测项目",
    };
    let editable = ref(false);

    let SClist = ref([]);
    let hjData = ref({});

    let c_baseHeaderData = ref([]);
    let c_tieqkHeaderData = ref([]);
    let c_tieqkHeaderDataMap = ref({});
    let c_wgHeaderData = ref([]);
    let c_spHeaderData = ref([]);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };
    function splitList(start, end) {
      var tlist;
      if (c_baseHeaderData.value.length >= end) {
        tlist = c_baseHeaderData.value.splice(start, end);
      } else {
        tlist = [];
      }
      console.log("tlist.....", tlist);
      return tlist;
    }

    const getListData = async () => {
      const data = await chongVoLast();
      parse(data);
    };
    function parse(data) {
      console.log(".........", data);
      headData.head = data.data.head;
      if (headData.head.reportTime != null)
        headData.head.reportTime = headData.head.reportTime.substr(0, 10);
      // headData.head.jieban1 = headData.head.jieban.substr(11, 5);
      // headData.head.jiaoban1 = headData.head.jiaoban.substr(11, 5);
      c_baseHeaderData.value = data.data.cbaseList;
      c_tieqkHeaderData.value = [data.data.ctieqk];
      c_tieqkHeaderDataMap = data.data.ctieqk;

      c_wgHeaderData.value = data.data.cwgList;
      c_spHeaderData.value = data.data.cSpList;
      c_baseHeaderData.value.filter((item) => {
        if (item.shijian != null) item.shijian11 = item.shijian.substr(11, 5);

        return item;
      });
      c_wgHeaderData.value.filter((item) => {
        if (item.shijian != null) item.shijian11 = item.shijian.substr(11, 5);

        return item;
      });
      c_spHeaderData.value.filter((item) => {
        if (item.shijian != null) item.shijian11 = item.shijian.substr(11, 5);

        return item;
      });

      hjData.value = {
        ...headData.head,
        ...c_tieqkHeaderDataMap,
      };
    }
    const saveData = async () => {
      editable = false;
      let data = {
        head: headData.head,
        cbaseList: c_baseHeaderData.value,
        ctieqk: c_tieqkHeaderData.value[0],
        cwgList: c_wgHeaderData.value,
        cSpList: c_spHeaderData.value,
      };
      console.log("save data...", data);
      const dt = await chongVoSave(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "底盖冲床工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("g01.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象

        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,
          t1: c_spHeaderData.value,
          t2: c_baseHeaderData.value,
          t3: c_wgHeaderData.value,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "502底盖冲床工序生产质量记录.docx");
      });
    }
    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };
    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      editable,
      getListData,
      headData,
      toImage,
      imageWrapper,
      labelName,
      exportWord,
      c_baseHeaderData,
      c_tieqkHeaderData,
      c_wgHeaderData,
      c_baseHeader,
      c_tieqkHeader,
      c_wgHeader,
      c_spHeaderData,
      c_spHeader,
      chongVoLast,
      chongVoSave,
      c_tieqkHeaderDataMap,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}

#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}

.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}

.title_form_input {
  font-size: 16px;
}
</style>
